_tw() {
    local i cur prev opts cmd
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="tw"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        tw)
            opts="-f -h -V --format --no-header --ignore-errors --infer-schema --separator --quote-char --widths --separator-length --no-flexible-width --theme --help --version <FILES>..."
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --format)
                    COMPREPLY=($(compgen -W "dsv parquet jsonl json arrow fwf" -- "${cur}"))
                    return 0
                    ;;
                -f)
                    COMPREPLY=($(compgen -W "dsv parquet jsonl json arrow fwf" -- "${cur}"))
                    return 0
                    ;;
                --infer-schema)
                    COMPREPLY=($(compgen -W "no fast full safe" -- "${cur}"))
                    return 0
                    ;;
                --separator)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --quote-char)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --widths)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --separator-length)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --theme)
                    COMPREPLY=($(compgen -W "monokai argonaut terminal" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

if [[ "${BASH_VERSINFO[0]}" -eq 4 && "${BASH_VERSINFO[1]}" -ge 4 || "${BASH_VERSINFO[0]}" -gt 4 ]]; then
    complete -F _tw -o nosort -o bashdefault -o default tw
else
    complete -F _tw -o bashdefault -o default tw
fi
